<?php

namespace FiloBlu\ScratchAndQuiz\Block\Adminhtml\ScratchAndQuiz\Helper;

use Magento\Store\Model\StoreManagerInterface;
use Magento\Framework\Data\Form\Element\File as FileField;

class File extends FileField {

    protected $_storeManager;

    public function __construct(
        StoreManagerInterface $storemanager,
        \Magento\Framework\Data\Form\Element\Factory $factoryElement,
        \Magento\Framework\Data\Form\Element\CollectionFactory $factoryCollection,
        \Magento\Framework\Escaper $escaper,
        $data = []
    ) {
        $this->_storeManager = $storemanager;
        parent::__construct($factoryElement, $factoryCollection, $escaper, $data);
        $this->setType('file');
    }

    public function getElementHtml() {
        $html = '';
        $this->addClass('input-file');
        $html.= parent::getElementHtml();

        if ($this->getValue()) {

            $mediaDirectory = $this->_storeManager->getStore()->getBaseUrl(
                \Magento\Framework\UrlInterface::URL_TYPE_MEDIA
            );
            $url = $mediaDirectory . '/filoblu/scratchandquiz' . $this->getValue();

//            if (!preg_match("/^http\:\/\/|https\:\/\//", $url)) {
//                $url = Mage::getBaseUrl('media') . '{{entity}}' . '/' . 'file' . $url;
//            }
            $html .= '<br /><a href="' . $url . '">' . $this->_getUrl() . '</a> ';
        }

        $html.= $this->_getDeleteCheckbox();
        return $html;
    }

    protected function _getDeleteCheckbox() {
        $html = '';
        if ($this->getValue()) {
            $label = 'Delete File';
            $html .= '<span class="delete-image">';
            $html .= '<input type="checkbox" name="' . parent::getName() . '[delete]" value="1" class="checkbox" id="' . $this->getHtmlId() . '_delete"' . ($this->getDisabled() ? ' disabled="disabled"' : '') . '/>';
            $html .= '<label for="' . $this->getHtmlId() . '_delete"' . ($this->getDisabled() ? ' class="disabled"' : '') . '> ' . $label . '</label>';
            $html .= $this->_getHiddenInput();
            $html .= '</span>';
        }
        return $html;
    }

    protected function _getHiddenInput() {
        return '<input type="hidden" name="' . parent::getName() . '[value]" value="' . $this->getValue() . '" />';
    }

    protected function _getUrl() {
        return $this->getValue();
    }

    public function getName() {
        return $this->getData('name');
    }

}
