<?php

namespace FiloBlu\ScratchAndQuiz\Controller\Adminhtml\ScratchAndQuiz;

use Magento\Backend\App\Action;

class Details extends \Magento\Backend\App\Action
{
    /**
     * Core registry
     *
     * @var \Magento\Framework\Registry
     */
    protected $_coreRegistry = null;

    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
    protected $resultLayoutFactory;

    protected $scratchAndQuiz;

    /**
     * @param Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     * @param \Magento\Framework\Registry $registry
     */
    public function __construct(
        Action\Context $context,
        \Magento\Framework\View\Result\LayoutFactory $resultLayoutFactory,
        \Magento\Framework\Registry $registry,
        \FiloBlu\ScratchAndQuiz\Model\ScratchAndQuizFactory $scratchAndQuiz
    )
    {
        $this->resultLayoutFactory = $resultLayoutFactory;
        $this->_coreRegistry = $registry;
        $this->scratchAndQuiz = $scratchAndQuiz;
        parent::__construct($context);
    }

    /**
     * {@inheritdoc}
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('FiloBlu_ScratchAndQuiz::config');
    }

    /**
     * Edit ScratchAndQuiz
     *
     * @return \Magento\Backend\Model\View\Result\Page|\Magento\Backend\Model\View\Result\Redirect
     * @SuppressWarnings(PHPMD.NPathComplexity)
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');

        $model = $this->scratchAndQuiz->create();

        if ($id) {
            $model->load($id);
            if (!$model->getId()) {
                $this->messageManager->addError(__('This ScratchAndQuiz no longer exists.'));
                /** \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
                $resultRedirect = $this->resultRedirectFactory->create();

                return $resultRedirect->setPath('*/*/');
            }
        }

        $this->_coreRegistry->register('filoblu_scratchandquiz', $model);

        $resultLayout = $this->resultLayoutFactory->create();

        $detailsBlock = $resultLayout->getLayout()->getBlock('scratchandquiz.edit.tab.details');
        if ($detailsBlock) {
            $detailsBlock->setScratchAndQuizDetails($this->getRequest()->getPost('scratchandquiz_details', null));
        }
        return $resultLayout;
    }
}
