<?php
namespace FiloBlu\ScratchAndQuiz\Controller\Adminhtml\ScratchAndQuizDetails;

use Magento\Backend\App\Action;

class Delete extends \Magento\Backend\App\Action
{

    protected $scratchAndQuizDetails;

    protected $scratchAndQuizDetailsTranslations;

    public function __construct(
        Action\Context $context,
        \FiloBlu\ScratchAndQuiz\Model\ScratchAndQuizDetailsFactory $scratchAndQuizDetails,
        \FiloBlu\ScratchAndQuiz\Model\ScratchAndQuizDetailsTranslationsFactory $scratchAndQuizDetailsTranslations
    )
    {
        parent::__construct($context);
        $this->scratchAndQuizDetails = $scratchAndQuizDetails;
        $this->scratchAndQuizDetailsTranslations = $scratchAndQuizDetailsTranslations;
    }

    /**
     * {@inheritdoc}
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('FiloBlu_ScratchAndQuiz::config');
    }

    /**
     * Delete action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        $storeId = $this->getRequest()->getParam('store',0);

        $isSavingTranslation = false;

        if ($id && $storeId != 0) {
            $isSavingTranslation = true;
        }

        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();
        if ($id) {
            try {

                if ($isSavingTranslation) {
                    $model = $this->scratchAndQuizDetailsTranslations->create();
                    $model->loadByParentAndStoreId($id,$storeId);
                }
                else {
                    $model = $this->scratchAndQuizDetails->create();
                    $model->load($id);
                }

                $model->delete();
                $this->messageManager->addSuccess(__('The scratchandquiz details has been deleted.'));

                if ($isSavingTranslation) {
                    return $resultRedirect->setPath('*/*/edit', ['id' => $id, 'store' => 0]);
                }
                else {
                    return $resultRedirect->setPath('*/*/');
                }

            } catch (\Exception $e) {
                $this->messageManager->addError($e->getMessage());
                return $resultRedirect->setPath('*/*/edit', ['id' => $id, 'store' => $storeId]);
            }
        }
        $this->messageManager->addError(__('We can\'t find a scratchandquiz details to delete.'));
        return $resultRedirect->setPath('*/*/');
    }
}