<?php
namespace FiloBlu\ScratchAndQuiz\Model\ResourceModel;

class ScratchAndQuizTranslations extends \Magento\Framework\Model\ResourceModel\Db\AbstractDb
{
    /**
     * Event Manager
     *
     * @var \Magento\Framework\Event\ManagerInterface
     */
    protected $eventManager;

    protected $connection;

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct()
    {
        $this->_init('filoblu_scratchandquiz_translations', 'id');
        $this->connection = $this->getConnection();
    }

    public function __construct(
        \Magento\Framework\Event\ManagerInterface $eventManager,
        \Magento\Framework\Model\ResourceModel\Db\Context $context
    )
    {
        $this->eventManager = $eventManager;

        parent::__construct($context);
    }

    public function loadByParentAndStoreId($parentId,$storeId) {

        $select = $this->connection->select()->from($this->getMainTable())->where('filoblu_scratchandquiz_id=:filoblu_scratchandquiz_id AND store_id=:store_id');

        $result = $this->connection->fetchRow($select, ['filoblu_scratchandquiz_id' => $parentId , 'store_id' => $storeId]);

        return $result;
    }
}
