<?php

namespace FiloBlu\ScratchAndQuiz\Model;

class ScratchAndQuizTranslations extends \Magento\Framework\Model\AbstractModel {

    const CACHE_TAG = 'fb_scratchandquiz';

    protected $_cacheTag = self::CACHE_TAG;
    
    public function __construct(
            \Magento\Framework\Model\Context $context,
            \Magento\Framework\Registry $registry,
            \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
            \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
            array $data = []
    ) {
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct() {
        $this->_init('FiloBlu\ScratchAndQuiz\Model\ResourceModel\ScratchAndQuizTranslations');
    }

    public function loadByParentAndStoreId($parentId,$storeId)
    {
        $result = $this->getResource()->loadByParentAndStoreId($parentId,$storeId);

        if ($result) {
            $this->addData($result);            
        }

        $this->_cacheTag = self::CACHE_TAG . '_' . $parentId;

        return $this;
    }

}
